﻿Type=Activity
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

'Activity module
Sub Process_Globals
	Public Filter_On As Boolean							: Filter_On = False
	Public Filtered_On As Boolean						: Filtered_On = False
	Public EarthRadius As Double							: EarthRadius = 6371	' km
	Public RowHeight As Float
	Public RowHeight_1 As Float 
	Public NumberOfColumns As Int						: NumberOfColumns = 9
	Public NumberOfColumns_1 As Int					: NumberOfColumns_1 = NumberOfColumns - 1
	Public NumberOfRows As Int								: NumberOfRows = 0
	Public ColName0 As String
	Public ColName(NumberOfColumns) As String
	Public CellLineWidth As Float
	Public CellWidth0, CellWidth0_1 As Float
	Public CellWidth(NumberOfColumns) As Float
	Public CellWidth_1(NumberOfColumns)  As Float
	Public CellWidthTotal(NumberOfColumns + 1)  As Float
	Public CellColor As Int
	Public SelectedRowColor As Int
	Public SelectedRow As Int								: SelectedRow = -1  ' unselected
	Public CellAlignment As Int
	Public CellTextSize As Float
	Public CellTextColor As Int
	Public HeaderHeight As Float
	Public HeaderColor As Int
	Public HeaderLineColor As Int
	Public HeaderTextColor As Int
	Type RowCol(Col As Int, Row As Int)
	
	Public GPSPathDelete As List
End Sub

Sub Globals
	Private btnGPSPathLoad, btnGPSPathSave, btnGPSPathDeletePoint, btnGPSPathDeleteFile As Panel
	Private btnGPSPathFilter, btnGPSPathFilterDel As Panel
	Private btnGPSPathFilterLine, btnGPSPathFilterSame As Panel
	Private pnlGPSPath0, pnlGPSPathToolbox, pnlGPSPathHeader0, pnlGPSPathHeader1 As Panel
	Private pnlGPSPathFilter, pnlGPSPathFilterToolBox As Panel
	
	Private edtGPSPathFilterMinDist, edtGPSPathFilterMinRadius As EditText
	
	Private lblGPSPathComment, lblGPSPathComment0 As Label
	Private lblGPSPathDateTime, lblGPSPathDate, lblGPSPathTime As Label
	Private lblToolTip, lblGPSPathFile, lblGPSPathNbPoints1 As Label
	Private lblGPSPathFilterNb0, lblGPSPathFilterNb1 As Label
	
	Private scvGPSPath0 As ScrollView
	Private scvGPSPath1 As ScrollView2D

	Private Dialog1 As FileDialog
	
	Private GPSFilterIndexes As List
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Private ph As Phone
	
	If Scaling.GetDevicePhysicalSize < 6 Then
		ph.SetScreenOrientation(1)		' portrait orientation only
	Else
		ph.SetScreenOrientation(-1)		' both orientations
	End If
	
	Activity.LoadLayout("gps_path")
	Activity.Title = "GPS path display"

	pnlGPSPath0.Color = Colors.RGB(165,42,42)
	
	If Main.GPSPathFilename = "" And Main.GPSPath.Size = 0 Then
		btnGPSPathSave.Visible = False
		btnGPSPathDeletePoint.Visible = False
		btnGPSPathDeleteFile.Visible = False
		lblGPSPathFile.Text = "  ---"
		lblGPSPathNbPoints1.Text = "---"
		lblGPSPathComment.Text = "  ---"
		lblGPSPathDate.Text = "  ---"
		lblGPSPathTime.Text = "  ---"
	Else
		btnGPSPathSave.Visible = True
		btnGPSPathDeleteFile.Visible = True
		If SelectedRow >= 0 Then
			btnGPSPathDeletePoint.Visible = True
		Else
			btnGPSPathDeletePoint.Visible = False
		End If
		lblGPSPathFile.Text = "  " & Main.GPSPathFilename
		lblGPSPathComment.Text = "  " & Main.GPSPathComment
		lblGPSPathNbPoints1.Text = Main.GPSPath.Size & " pnts" 
		If Main.GPSPathTime0 > 0 Then
			lblGPSPathDate.Text = "  " & DateTime.Date(Main.GPSPathTime0)
			lblGPSPathTime.Text = "  " & DateTime.Time(Main.GPSPathTime0)
		Else
			lblGPSPathDate.Text = "  ---"
			lblGPSPathTime.Text = "  ---"
		End If
	End If
	
	lblToolTip.BringToFront
	InitGPSPathDisplay
	FillGPSPathTable
	
	If Not(GPSFilterIndexes.IsInitialized) Then
		GPSFilterIndexes.Initialize
	End If
End Sub

Sub Activity_Resume
	Main.GPSPathModified = False
	If Main.GPSPathFilename <> "" Then
		lblGPSPathFile.Text = "  " & Main.GPSPathFilename
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If Filter_On = True Then
		pnlGPSPathFilter.Visible = False
		pnlGPSPathFilterToolBox.Visible = False
		Main.GPSFilterDelta = edtGPSPathFilterMinDist.Text
		Main.GPSFilterRadius = edtGPSPathFilterMinRadius.Text
		If Filtered_On Then
			GPSPathUnFilter
		End If
		Filter_On = False
		Return True
	End If
	Return False
End Sub

Sub ToolTip(txt As String)
	If txt = "" Then
		lblToolTip.Text = ""
		lblToolTip.Visible = False
	Else
		lblToolTip.Text = txt
		lblToolTip.Visible = True
	End If
End Sub

Sub btnGPSPathSave_Touch(Action As Int, x As Float, y As Float)
	Private bmd As BitmapDrawable
	Private Send As Panel
	
	Send = Sender
	
	Select Action
	Case Activity.ACTION_DOWN
		ToolTip("Save the GPS path.")
		bmd.Initialize(LoadBitmap(File.DirAssets, "btnsave1.png"))
		Send.Background = bmd
	Case Activity.ACTION_UP
		bmd.Initialize(LoadBitmap(File.DirAssets, "btnsave0.png"))
		Send.Background = bmd
		ToolTip("")
		If x > 0 And x < Send.Width  And y > 0 And y < Send.Height Then
			StartActivity("GPSSave")
		End If
	End Select
End Sub

Sub btnGPSPathLoad_Touch(Action As Int, x As Float, y As Float)
	Private Answ As Int
	Private txt As String
	Private bmd As BitmapDrawable
	
	Select Action
	Case Activity.ACTION_DOWN
		ToolTip("Load a GPS path file.")
		bmd.Initialize(LoadBitmap(File.DirAssets, "btnload1.png"))
		btnGPSPathLoad.Background = bmd
	Case Activity.ACTION_UP
		If x > 0 And x < btnGPSPathLoad.Width  And y > 0 And y < btnGPSPathLoad.Height Then
			Dialog1.FilePath = Main.GPSDir
			Dialog1.FileFilter = ".GPP"
			Answ = Dialog1.Show("GPS files", "Load", "Cancel", "", Null)
			If Answ = DialogResponse.POSITIVE Then
				txt = Dialog1.ChosenName
				If txt.EndsWith(".GPP") = True Then
					Main.GPSPathFilename = txt
					GPSModule.LoadPath
					Main.MapZoomCalculated = False
					ClearTable
					FillGPSPathTable
					lblGPSPathFile.Text = "  " & Main.GPSPathFilename
					lblGPSPathComment.Text = "  " & Main.GPSPathComment
					lblGPSPathNbPoints1.Text = Main.GPSPath.Size & " pnts"
					If Main.GPSPathTime0 > 0 Then
						lblGPSPathDate.Text = "  " & DateTime.Date(Main.GPSPathTime0)
						lblGPSPathTime.Text = "  " & DateTime.Time(Main.GPSPathTime0)
					Else
						lblGPSPathDate.Text = "  ---"
						lblGPSPathTime.Text = "  ---"
					End If
				Else
					Return
				End If
			End If
		End If
		bmd.Initialize(LoadBitmap(File.DirAssets, "btnload0.png"))
		btnGPSPathLoad.Background = bmd
		ToolTip("")
	End Select
End Sub

Sub btnGPSPathDeletePoint_Touch(Action As Int, x As Float, y As Float)
	Private bmd As BitmapDrawable
	Private Answ As Int
	Private txt As String
	
	Select Action
	Case Activity.ACTION_DOWN
		ToolTip("Delete the selected locations.")
		bmd.Initialize(LoadBitmap(File.DirAssets, "btndeletepoint1.png"))
		btnGPSPathDeletePoint.Background = bmd
	Case Activity.ACTION_UP
		If x > 0 And x < btnGPSPathDeletePoint.Width  And y > 0 And y < btnGPSPathDeletePoint.Height Then
			txt = "Do you really want to delete" & CRLF
			txt = txt & "point " & SelectedRow & " ?"
			Answ = Msgbox2(txt, "A T T E N T I O N", "Yes", "", "No", Null)
			If Answ = DialogResponse.POSITIVE Then
				GPSPathDeletePoint
			End If
		End If
		bmd.Initialize(LoadBitmap(File.DirAssets, "btndeletepoint0.png"))
		btnGPSPathDeletePoint.Background = bmd
		ToolTip("")
	End Select
End Sub

Sub btnGPSPathDeleteFile_Touch(Action As Int, x As Float, y As Float)
	Private bmd As BitmapDrawable
	Private Answ As Int
	Private txt As String
	
	Select Action
	Case Activity.ACTION_DOWN
		ToolTip("Delete the current file.")
		bmd.Initialize(LoadBitmap(File.DirAssets, "btndeletefile1.png"))
		btnGPSPathDeleteFile.Background = bmd
	Case Activity.ACTION_UP
		If x > 0 And x < btnGPSPathDeleteFile.Width  And y > 0 And y < btnGPSPathDeleteFile.Height Then
			txt = "Do you really want to delete" & CRLF
			txt = txt & "file " & Main.GPSPathFilename & " ?"
			Answ = Msgbox2(txt, "A T T E N T I O N", "Yes", "", "No", Null)
			If Answ = DialogResponse.POSITIVE Then
				File.Delete(Main.GPSDir, Main.GPSPathFilename)
				Main.GPSPathFilename = ""
				lblGPSPathFile.Text = "  " & Main.GPSPathFilename
				ClearTable
				Main.MapZoomCalculated = False
				btnGPSPathDeleteFile.Visible = False
			End If
		End If
		bmd.Initialize(LoadBitmap(File.DirAssets, "btndeletefile0.png"))
		btnGPSPathDeleteFile.Background = bmd
		ToolTip("")
	End Select
End Sub

Sub GPSPathDeletePoint
	Private i, j, m, m1, n, n1 As Int
	
	' removes the point from the list
	Main.GPSPath.RemoveAt(SelectedRow)
'	Main.GPSPathModified = True
	If SelectedRow = NumberOfRows - 1 Then
		' if last row
		n = (NumberOfRows - 1) * NumberOfColumns
		For i = NumberOfColumns - 2 To 0 Step -1			'*****
			scvGPSPath1.Panel.RemoveViewAt(n + i)
		Next
		SelectedRow = -1
		NumberOfRows = NumberOfRows - 1
		scvGPSPath0.Panel.Height = NumberOfRows * RowHeight
		scvGPSPath1.Panel.Height = NumberOfRows * RowHeight
		Return
	End If
	
	' moves, in the table, the cell values one line up 
	For i = SelectedRow To NumberOfRows - 2
		m = i * NumberOfColumns
		m1 = (i + 1) * NumberOfColumns
		For j = 0 To NumberOfColumns_1
			n = m + j
			n1 = m1 + j
			Private lbl, lbl1 As Label
			lbl =	scvGPSPath1.Panel.GetView(n)
			lbl1 =	scvGPSPath1.Panel.GetView(n1)
			Private GPSloc1 As GPSLocation
			GPSloc1.Initialize
			GPSloc1 = Main.GPSPath.Get(i)
			lbl.Text = lbl1.Text
		Next
	Next
	' removes the views of the last line in the table
	n = (NumberOfRows - 1) * NumberOfColumns
	For i = NumberOfColumns_1 To 0 Step -1
		scvGPSPath1.Panel.RemoveViewAt(n + i)
	Next
	
	' updates the values of Time, Distance, DistTot, Speed and Bearing
	If SelectedRow = 0 Then
		Private GPSloc1 As GPSLocation
		GPSloc1.Initialize
		GPSloc1 = Main.GPSPath.Get(0)
		GPSloc1.Distance = 0
		GPSloc1.DistTot = 0
		GPSloc1.Speed = 0
		Main.GPSPath.Set(SelectedRow, GPSloc1)
		Private lbl As Label
		lbl = scvGPSPath1.Panel.GetView(6)
		lbl.Text = GPSloc1.Distance
		Private lbl As Label
		lbl = scvGPSPath1.Panel.GetView(7)
		lbl.Text = GPSloc1.DistTot
		Private lbl As Label
		lbl = scvGPSPath1.Panel.GetView(5)
		lbl.Text = GPSloc1.Speed
		Main.GPSPathTime0 = GPSloc1.Time
		For i = 0 To NumberOfRows - 2
			Private GPSloc1 As GPSLocation
			GPSloc1.Initialize
			GPSloc1 = Main.GPSPath.Get(i)
			Private lbl As Label
			n = i * NumberOfColumns + 3
			lbl = scvGPSPath1.Panel.GetView(n)
			lbl.Text = (GPSloc1.Time - Main.GPSPathTime0) 
		Next
	Else
		Private GPSloc1, GPSloc2 As GPSLocation
		Private loc1, loc2 As Location
		GPSloc1.Initialize
		GPSloc2.Initialize
		loc1.Initialize
		loc2.Initialize
		GPSloc1 = Main.GPSPath.Get(SelectedRow - 1)
		loc1.Latitude = GPSloc1.Latitude
		loc1.Longitude = GPSloc1.Longitude
		GPSloc2 = Main.GPSPath.Get(SelectedRow)
		loc2.Latitude = GPSloc2.Latitude
		loc2.Longitude = GPSloc2.Longitude
		GPSloc2.Distance = Round2(loc1.DistanceTo(loc2), 3)
		GPSloc2.Bearing = Round2(loc1.BearingTo(loc2), 1)
		GPSloc2.Speed =  Round2(GPSloc2.Distance / (GPSloc2.Time - GPSloc1.Time) * 1000, 3)
		Main.GPSPath.Set(SelectedRow, GPSloc2)
		n = SelectedRow * NumberOfColumns + 6
		Private lbl As Label
		lbl = scvGPSPath1.Panel.GetView(n)
		lbl.Text = DispDistance(GPSloc2.Distance)
		n = SelectedRow * NumberOfColumns + 5
		Private lbl As Label
		lbl = scvGPSPath1.Panel.GetView(n)
		lbl.Text = GPSloc2.Speed
	End If
	
	' updates DistTot in all rows after the selected one
	For i = SelectedRow To NumberOfRows - 2
		GPSloc2 = Main.GPSPath.Get(i)
		GPSloc2.DistTot = Round2(GPSloc1.DistTot + GPSloc2.Distance, 2)
		n = i * NumberOfColumns + 7
		lbl = scvGPSPath1.Panel.GetView(n)
		lbl.Text = DispDistance(GPSloc2.DistTot)
		GPSloc1 = GPSloc2
	Next
	
	' unselects the row and changes its color
	If SelectedRow < NumberOfRows - 1 Then
		ChangeCellSelection(SelectedRow, 0)	
	End If
	SelectedRow = -1
	
	NumberOfRows = NumberOfRows - 1
	scvGPSPath0.Panel.Height = NumberOfRows * RowHeight
	scvGPSPath1.Panel.Height = NumberOfRows * RowHeight
	scvGPSPath1.Panel.Width = CellWidthTotal(NumberOfColumns)
End Sub

Sub btnGPSPathFilter_Touch(Action As Int, x As Float, y As Float)
	Private bmd As BitmapDrawable
	
	Select Action
	Case Activity.ACTION_DOWN
		ToolTip("Filter the current path." & CRLF & "Locations on a same line or" & CRLF & "within a given radius can be removed.")
		bmd.Initialize(LoadBitmap(File.DirAssets, "btnfilterline1.png"))
		btnGPSPathFilter.Background = bmd
	Case Activity.ACTION_UP
		If x > 0 And x < btnGPSPathFilter.Width  And y > 0 And y < btnGPSPathFilter.Height Then
			Filter_On = Not(Filter_On)
		End If
		If Filter_On = True Then
			pnlGPSPathFilter.Visible = True
			pnlGPSPathFilterToolBox.Visible = True
			edtGPSPathFilterMinDist.Text = Main.GPSFilterDelta
			edtGPSPathFilterMinRadius.Text = Main.GPSFilterRadius
			If Filtered_On Then
				GPSPathFilterLine
			Else
				lblGPSPathFilterNb0.Text = "Nb. of points"
				lblGPSPathFilterNb1.Text = Main.GPSPath.Size
			End If		
		End If
		bmd.Initialize(LoadBitmap(File.DirAssets, "btnfilterline0.png"))
		btnGPSPathFilter.Background = bmd
		ToolTip("")
	End Select
End Sub

Sub btnGPSPathFilterLine_Touch(Action As Int, x As Float, y As Float)
	Private bmd As BitmapDrawable
	
	Select Action
	Case Activity.ACTION_DOWN
		If Filtered_On = False Then
			ToolTip("Filter the current path." & CRLF & "Locations on a same line closer" & CRLF &"than " & edtGPSPathFilterMinDist.Text & " meters are removed.")
			bmd.Initialize(LoadBitmap(File.DirAssets, "btnFilterLine1.png"))
		Else
			ToolTip("Unfilter the current path.")
			bmd.Initialize(LoadBitmap(File.DirAssets, "btnFilterLine0.png"))
		End If
	Case Activity.ACTION_UP
		If x > 0 And x < btnGPSPathFilterLine.Width  And y > 0 And y < btnGPSPathFilterLine.Height Then
			Filtered_On = Not(Filtered_On)
			If Filtered_On = False Then
				bmd.Initialize(LoadBitmap(File.DirAssets, "btnFilterLine0.png"))
				GPSPathUnFilter
				btnGPSPathFilterDel.Visible = False
			Else
				bmd.Initialize(LoadBitmap(File.DirAssets, "btnFilterLine1.png"))
				Main.GPSFilterDelta = edtGPSPathFilterMinDist.Text
				GPSPathFilterLine
				If GPSPathDelete.Size = 0 Then
					btnGPSPathFilterDel.Visible = False
					bmd.Initialize(LoadBitmap(File.DirAssets, "btnFilterLine0.png"))
					Filtered_On = False
					ToastMessageShow("No locations found", False)
				Else
					btnGPSPathFilterDel.Visible = True
				End If
			End If
			btnGPSPathFilterLine.Background = bmd
		End If
		ToolTip("")
	End Select
End Sub

Sub btnGPSPathFilterSame_Touch(Action As Int, x As Float, y As Float)
	Private bmd As BitmapDrawable
	
	Select Action
	Case Activity.ACTION_DOWN
		If Filtered_On = False Then
			ToolTip("Filter the current path." & CRLF & "Locations closer than " & edtGPSPathFilterMinRadius.Text & " meters" & CRLF & "to the previous location are removed.")
			bmd.Initialize(LoadBitmap(File.DirAssets, "btnFilterSame1.png"))
		Else
			ToolTip("Unfilter the current path, close locations.")
			bmd.Initialize(LoadBitmap(File.DirAssets, "btnFilterSame0.png"))
		End If
	Case Activity.ACTION_UP
		If x > 0 And x < btnGPSPathFilterSame.Width  And y > 0 And y < btnGPSPathFilterSame.Height Then
			Filtered_On = Not(Filtered_On)
			If Filtered_On = False Then
				bmd.Initialize(LoadBitmap(File.DirAssets, "btnFilterSame0.png"))
				GPSPathUnFilter
				btnGPSPathFilterDel.Visible = False
			Else
				bmd.Initialize(LoadBitmap(File.DirAssets, "btnFilterSame1.png"))
				Main.GPSFilterRadius = edtGPSPathFilterMinRadius.Text
				GPSPathFilterSame
				If GPSPathDelete.Size = 0 Then
					btnGPSPathFilterDel.Visible = False
					bmd.Initialize(LoadBitmap(File.DirAssets, "btnFilterSame0.png"))
					Filtered_On = False
					ToastMessageShow("No locations found", False)
				Else
					btnGPSPathFilterDel.Visible = True
				End If
			End If
			btnGPSPathFilterSame.Background = bmd
		End If
		ToolTip("")
	End Select
End Sub

Sub btnGPSPathFilterDel_Touch(Action As Int, x As Float, y As Float)
	Private bmd As BitmapDrawable
	Private Answ As Int
	
	Select Action
	Case Activity.ACTION_DOWN
		ToolTip("Delete the selected locations.")
		bmd.Initialize(LoadBitmap(File.DirAssets, "btngpsfilterdel1.png"))
		btnGPSPathFilterDel.Background = bmd
	Case Activity.ACTION_UP
		If x > 0 And x < btnGPSPathFilterDel.Width  And y > 0 And y < btnGPSPathFilterDel.Height Then
			Answ = Msgbox2("Do you really want to delete the selected points ?", "A T T E N T I O N", "Yes", "", "No", Null)
			If Answ = DialogResponse.POSITIVE Then
				GPSPathFilterDelete
				btnGPSPathFilterDel.Visible = False
				btnGPSPathDeletePoint.Visible = False
				pnlGPSPathFilter.Visible = False
				pnlGPSPathFilterToolBox.Visible = False
				bmd.Initialize(LoadBitmap(File.DirAssets, "btnfilterline0.png"))
				btnGPSPathFilter.Background = bmd
				bmd.Initialize(LoadBitmap(File.DirAssets, "btnfilterline0.png"))
				btnGPSPathFilterLine.Background = bmd
				bmd.Initialize(LoadBitmap(File.DirAssets, "btnfiltersame0.png"))
				btnGPSPathFilterSame.Background = bmd
				Filtered_On = False
				Filter_On = False
				SelectedRow = -1
			End If
		End If
		bmd.Initialize(LoadBitmap(File.DirAssets, "btngpsfilterdel0.png"))
		ToolTip("")
		btnGPSPathFilterDel.Background = bmd
	End Select
End Sub

Sub pnlGPSPathFilterToolBox_Touch(Action As Int, x As Float, y As Float)
	' Dummy routine to consume the touch event for views below
End Sub

Sub GPSPathUnFilter
	Private i As Int
	
	For i = 0 To GPSPathDelete.Size - 1
		ChangeCellSelection(GPSPathDelete.Get(i), 2)
	Next
	lblGPSPathFilterNb0.Text = "Nb. of points"
	lblGPSPathFilterNb1.Text = Main.GPSPath.Size
	SelectedRow = -1
	btnGPSPathDeletePoint.Visible = True
End Sub

Sub GPSPathFilterLine
	Private i0, i1 As Int
	Private x0, x1, x2 As Double
	Private y0, y1, y2 As Double
	Private g As GPSLocation
	Private d As Double
	
	GPSPathDelete.Initialize
	i0 = Main.GPSPath.Size - 1
	g.Initialize
	g = Main.GPSPath.Get(i0)
	y0 = GPSCalcY(g.Latitude, g.Longitude)
	x0 = GPSCalcX(g.Latitude)

	i1 = i0 - 1
	g = Main.GPSPath.Get(i1)
	y1 = GPSCalcY(g.Latitude, g.Longitude)
	x1 = GPSCalcX(g.Latitude)
	For i = Main.GPSPath.Size - 3 To 0 Step - 1
		g = Main.GPSPath.Get(i)
		y2 = GPSCalcY(g.Latitude, g.Longitude)
		x2 = GPSCalcX(g.Latitude)
		d = GPSPathCalcDelta(x0, y0, x1, y1, x2, y2, True)
		If d <= Main.GPSFilterDelta Then
			GPSPathDelete.Add(i + 1)
			ChangeCellSelection(i + 1, 1)
		End If
		x0 = x1
		y0 = y1
		x1 = x2
		y1 = y2
	Next
	lblGPSPathFilterNb0.Text = "Nb. of points found"
	lblGPSPathFilterNb1.Text = GPSPathDelete.Size & " / " & Main.GPSPath.Size
End Sub

Sub GPSPathFilterSame
	Private g0, g1 As GPSLocation
	Private l0 As Location
	
	GPSPathDelete.Initialize
	g0.Initialize
	g1.Initialize
	l0.Initialize
	g0 = Main.GPSPath.Get(0)
	l0.Latitude = g0.Latitude
	l0.Longitude = g0.Longitude
	For i = 1 To Main.GPSPath.Size - 1
		g1 = Main.GPSPath.Get(i)
		Private l1 As Location
		l1.Initialize
		l1.Latitude = g1.Latitude
		l1.Longitude = g1.Longitude
		If l0.DistanceTo(l1) <= Main.GPSFilterRadius Then
			GPSPathDelete.Add(i)
			ChangeCellSelection(i, 1)
		Else
			g0 = g1
			l0 = l1
		End If
	Next
	lblGPSPathFilterNb0.Text = "Nb. of points found"
	lblGPSPathFilterNb1.Text = GPSPathDelete.Size & " / " & Main.GPSPath.Size
End Sub

Sub GPSCalcY(lat As Double, lng As Double) As Double
	' calculates the latitude distance in km from coordinates 0, 0
	Return lng * EarthRadius / 180 * cPI  * CosD(lat)
End Sub

Sub GPSCalcX(lat As Double) As Double
	' calculates the longitude distance in km from coordinates 0, 0
	Return lat * EarthRadius / 180 * cPI
End Sub

Sub GPSPathCalcDelta(x1 As Double, y1 As Double, xp As Double, yp As Double, x2 As Double, y2 As Double, m As Boolean) As Double
	' calculates the distance between the point(xp,yp) 
	' and the line defined by the two ponts (x1,y1) and (x2,y2)
	' m = False returns distance in km
	' m = True  returns distance in m
	
	Private d, x, y As Double
	
	d = Abs((xp - x1) * (x2 - x1) + (yp - y1) * (y2 - y1))/((x2 - x1) * (x2 - x1) +  (y2 - y1) * (y2 - y1)) 
	x = x1 + d * (x2 - x1)
	y = y1 + d * (y2 - y1)
	d = Sqrt((xp - x) * (xp - x) + (yp - y) * (yp - y))
	If m = False Then
		Return d
	Else
		Return d * 1000
	End If
End Sub

Sub GPSPathFilterDelete
	' removes the selected fixes (points) by the filter
	' clears the table and fills it again
	Private i, i0, i1, st As Int
	
	If GPSPathDelete.Get(0) < GPSPathDelete.Get(GPSPathDelete.Size - 1) Then
		i0 = GPSPathDelete.Size - 1
		i1 = 0
		st = -1
	Else
		i0 = 0
		i1 = GPSPathDelete.Size - 1
		st = 1
	End If
	
	For i = i0 To i1 Step st
		SelectedRow = GPSPathDelete.Get(i)
		GPSPathDeletePoint
	Next
	ClearTable
	FillGPSPathTable
	GPSPathDelete.Initialize
	lblGPSPathFilterNb0.Text = "Nb. of points"
	lblGPSPathFilterNb1.Text = Main.GPSPath.Size
	lblGPSPathNbPoints1.Text = Main.GPSPath.Size & " pnts"
End Sub

Sub InitGPSPathDisplay
	' Initializes the variables and the table to display a GPS path
	Private i As Int
	
	CellLineWidth = 1dip * Scaling.Scale
	HeaderHeight = 38dip * Scaling.Scale
	RowHeight = 30dip * Scaling.Scale
	RowHeight_1 = RowHeight - CellLineWidth
	
	scvGPSPath0.Top = HeaderHeight
	scvGPSPath0.Width = pnlGPSPath0.Width
	scvGPSPath0.Height = pnlGPSPath0.Height - HeaderHeight
	scvGPSPath0.Enabled = False
	
	CellAlignment = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
	CellTextSize = 14 * Scaling.Scale
	CellColor = Colors.RGB(255,250,205)
	SelectedRowColor = Colors.RGB(255,196,196)
	CellTextColor = Colors.RGB(165,42,42)
	HeaderColor = Colors.Blue
	HeaderLineColor = Colors.Yellow
	HeaderTextColor = Colors.Yellow
	
	ColName0 = "ID"
	ColName(0) = "Latitude" & CRLF & "[°]"
	ColName(1) = "Longitude" & CRLF & "[°]"
	ColName(2) = "Altitude" & CRLF & "[" & Main.AltitudeUnitText(Main.AltitudeUnitIndex) & "]"
	ColName(3) = "Time" & CRLF & "[s]"
	ColName(4) = "Bearing" & CRLF & "[°]"
	ColName(5) = "Speed" & CRLF & "[" & Main.SpeedUnitText(Main.SpeedUnitIndex) & "]"
	ColName(6) = "Distance" & CRLF & "[" & Main.DistanceUnitText(Main.DistanceUnitIndex) & "]"
	ColName(7) = "Dist tot" & CRLF & "[" & Main.DistanceUnitText(Main.DistanceUnitIndex) & "]"
	ColName(8) = "Marker"

	CellWidth0 = 40dip * Scaling.Scale
	CellWidth0_1 = CellWidth0 - 2 * CellLineWidth
	CellWidth(0) = 80dip * Scaling.Scale
	CellWidth(1) = 80dip * Scaling.Scale
	CellWidth(2) = 60dip * Scaling.Scale
	CellWidth(3) = 60dip * Scaling.Scale
	CellWidth(4) = 60dip * Scaling.Scale
	CellWidth(5) = 60dip * Scaling.Scale
	CellWidth(6) = 70dip * Scaling.Scale
	CellWidth(7) = 70dip * Scaling.Scale
	CellWidth(8) = 60dip * Scaling.Scale
	
	CellWidthTotal(0) = 0
	For i = 0 To NumberOfColumns_1
		CellWidth_1(i) = CellWidth(i) - CellLineWidth
		CellWidthTotal(i + 1) = CellWidthTotal(i) + CellWidth(i)
	Next
	
	' Checks if the table width is smaller than the screen width
	' If yes streches all the column widths
	Log(CellWidthTotal(NumberOfColumns))
	Log(100%x)
	If CellWidthTotal(NumberOfColumns) < 100%x - CellWidth0 Then
		Private WidthScale As Double
		WidthScale = (100%x - CellWidth0) / CellWidthTotal(NumberOfColumns)
	Log(WidthScale)
		For i = 0 To NumberOfColumns_1
			CellWidth(i) = CellWidth(i) * WidthScale
			CellWidth_1(i) = CellWidth(i) - CellLineWidth
			CellWidthTotal(i + 1) = CellWidthTotal(i) + CellWidth(i)
		Next
	End If
	Log(CellWidthTotal(NumberOfColumns))
	
	pnlGPSPathHeader0.Initialize("")
	pnlGPSPath0.AddView(pnlGPSPathHeader0, 0, 0, CellWidth0, HeaderHeight)
	pnlGPSPathHeader0.Color = HeaderLineColor
		
	Private lbl As Label
	lbl.Initialize("Header")
	lbl.Tag = -1
	lbl.Color = HeaderColor
	lbl.TextColor = HeaderTextColor
	lbl.TextSize = 14 * Scaling.Scale
	lbl.Typeface = Typeface.DEFAULT_BOLD
	lbl.Gravity = CellAlignment
	lbl.Text = ColName0
	pnlGPSPathHeader0.AddView(lbl, 0, 0, CellWidth0_1,HeaderHeight)

	pnlGPSPathHeader1.Initialize("")
	Activity.AddView(pnlGPSPathHeader1, CellWidth0, pnlGPSPath0.Top, 100%x - CellWidth0, HeaderHeight)
	pnlGPSPathHeader1.Color = HeaderLineColor

	scvGPSPath1.Initialize(10dip, 10dip, "scvGPSPath1")
	Activity.AddView(scvGPSPath1, CellWidth0, pnlGPSPathHeader1.Top + pnlGPSPathHeader1.Height, 100%x - CellWidth0, pnlGPSPath0.Height - HeaderHeight)
	scvGPSPath1.Color = Colors.RGB(165,42,42)
	scvGPSPath1.Panel.Color = Colors.RGB(165,42,42)
	pnlGPSPathHeader0.BringToFront

	For i = 0 To NumberOfColumns_1
		CellWidth_1(i) = CellWidth(i) - CellLineWidth
		CellWidthTotal(i + 1) = CellWidthTotal(i) + CellWidth(i)
		Private lbl As Label
		lbl.Initialize("Header")
		lbl.Tag = i
		lbl.Color = HeaderColor
		lbl.TextColor = HeaderTextColor
		lbl.TextSize = 14 * Scaling.Scale
		lbl.Typeface = Typeface.DEFAULT_BOLD
		lbl.Gravity = CellAlignment
		lbl.Text = ColName(i)
		pnlGPSPathHeader1.AddView(lbl, CellWidthTotal(i), 0, CellWidth_1(i),HeaderHeight)
	Next
	scvGPSPath1.Panel.Width = CellWidthTotal(NumberOfColumns)
	pnlGPSPathHeader1.Width = CellWidthTotal(NumberOfColumns)
	pnlGPSPathHeader0.BringToFront
	pnlGPSPathHeader1.SendToBack
End Sub

Sub ClearTable
	' Clears the whole table, in fact removes all the views from the ScrollView
	Private i As Int
	
	For i = scvGPSPath0.Panel.NumberOfViews - 1 To 0 Step -1
		scvGPSPath0.Panel.RemoveViewAt(i)
	Next
	For i = scvGPSPath1.Panel.NumberOfViews - 1 To 0 Step -1
		scvGPSPath1.Panel.RemoveViewAt(i)
	Next
End Sub

Sub FillGPSPathTable
	' Fills the table with the GPS path data
	Private i As Int
	
	NumberOfRows = 0
	
	For i = 0 To Main.GPSPath.Size - 1
		Private loc As GPSLocation
		loc = Main.GPSPath.Get(i)
		If i = 0 Then
			Main.GPSPathTime0 = loc.Time
		End If
		GPSPathAddRow(loc)
	Next
	scvGPSPath0.Panel.Height = NumberOfRows * RowHeight
	scvGPSPath1.Panel.Height = NumberOfRows * RowHeight
End Sub

Sub GPSPathAddRow(Values As GPSLocation)
' Adds a row to the table
	Private i As Int
	
	Private l As Label
	l.Initialize("cell")
	l.Text = NumberOfRows
	l.Gravity = CellAlignment
	l.TextSize = CellTextSize
	l.TextColor = CellTextColor
	l.Color = CellColor
	Private rc As RowCol
	rc.Initialize
	rc.Col = -1
	rc.Row = NumberOfRows
	l.Tag = rc
	scvGPSPath0.Panel.AddView(l, 0, RowHeight * NumberOfRows, CellWidth0_1, RowHeight_1)

	For i = 0 To NumberOfColumns_1
		Private l As Label
		l.Initialize("cell")
		Select i
		Case 0
			l.Text = NumberFormat2(Values.Latitude, 1, 6, 0, False)
		Case 1
			l.Text = NumberFormat2(Values.Longitude, 1, 6, 0, False)
		Case 2
			l.Text = DispAltitude(Values.Altitude)
		Case 3
			l.Text = (Values.Time - Main.GPSPathTime0) / 1000
		Case 4
			l.Text = NumberFormat2(Values.Bearing, 1, 1, 0, False)
		Case 5
			l.Text = NumberFormat2(Values.Speed * Main.SpeedUnitRatio(Main.SpeedUnitIndex), 1 ,2, 0, False)
		Case 6
			l.Text = DispDistance(Values.Distance)
		Case 7
			l.Text = DispDistance(Values.DistTot)
		Case 8
			If Values.Marker = True Then
				l.Text = "√"
			Else
				l.Text = "-"
			End If
		End Select
		
		l.Gravity = CellAlignment
		l.TextSize = CellTextSize
		l.TextColor = CellTextColor
		l.Color = CellColor
		Private rc As RowCol
		rc.Initialize
		rc.Col = i
		rc.Row = NumberOfRows
		l.Tag = rc
		scvGPSPath1.Panel.AddView(l, CellWidthTotal(i), RowHeight * NumberOfRows, CellWidth_1(i), RowHeight_1)
	Next
	NumberOfRows = NumberOfRows + 1
End Sub

Sub scvGPSPath1_ScrollChanged(PosX As Int, PosY As Int)
	scvGPSPath0.ScrollPosition = PosY
	pnlGPSPathHeader1.Left = CellWidth0 - PosX
End Sub

Sub Cell_Click
	Private Send As Label
	Private rc As RowCol
	Private GPSLoc As GPSLocation
	
	Send = Sender
	rc = Send.Tag
	If rc.Col < 8 Then
		ChangeCellSelection(rc.Row, 0)
	Else
		GPSLoc = Main.GPSPath.Get(rc.Row)
		GPSLoc.Marker = Not(GPSLoc.Marker)
		Main.GPSPath.Set(rc.Row, GPSLoc)
		If GPSLoc.Marker = True Then
			Send.Text = "√"
		Else
			Send.Text = "-"
		End If
'		Main.GPSPathModified = True
	End If
End Sub

Sub ChangeCellSelection(row As Int, mode As Int)	
	'Changes the cell color depending on the selected row
	Private i, j As Int
	
	' set standard color to the labels of the previous selected row
	If SelectedRow >= 0 And mode <> 1 Then
		scvGPSPath0.Panel.GetView(SelectedRow).Color = CellColor
		j = SelectedRow * NumberOfColumns
		For i = 0 To NumberOfColumns - 1
			scvGPSPath1.Panel.GetView(j + i).Color = CellColor
		Next
	End If
		
	If SelectedRow = row Then	
		' the user selects the same row > unselected 	
		SelectedRow = -1
		btnGPSPathDeletePoint.Visible = False
	Else
		' set selected color to the labels of the current selected row
		SelectedRow = row
		If mode < 2 Then
			scvGPSPath0.Panel.GetView(SelectedRow).Color = SelectedRowColor
			j = SelectedRow * NumberOfColumns
			For i = 0 To NumberOfColumns - 1
				scvGPSPath1.Panel.GetView(j + i).Color = SelectedRowColor
			Next
			btnGPSPathDeletePoint.Visible = True
		End If
	End If
End Sub

Sub Header_Click
	Private Send As Label
	Private i, n, Answ As Int
	Private txt As String
	
	Send = Sender
	
	Select Send.Tag
	Case 2
		Main.AltitudeUnitIndex = Main.AltitudeUnitIndex + 1
		If Main.AltitudeUnitIndex > Main.AltitudeUnitNumber - 1 Then
			Main.AltitudeUnitIndex = 0
		End If
		UpdateDispAltitude
	Case 5
		Main.SpeedUnitIndex = Main.SpeedUnitIndex + 1
		If Main.SpeedUnitIndex > Main.SpeedUnitNumber - 1 Then
			Main.SpeedUnitIndex = 0
		End If
		UpdateDispSpeed
	Case 6, 7
		Main.DistanceUnitIndex = Main.DistanceUnitIndex + 1
		If Main.DistanceUnitIndex > Main.DistanceUnitNumber - 1 Then
			Main.DistanceUnitIndex = 0
		End If
		UpdateDispDistance
	Case 8
		txt = "Do you want to set" & CRLF
		txt = txt & "or remove ALL markers ?"
		Answ = Msgbox2(txt, "A T T E N T I O N", "Set", "Cancel", "Remove", Null)
		Private Set As Boolean
		Private Ch As Char
		If Answ = DialogResponse.POSITIVE Then
			Set = True
			Ch = "√"
		Else If Answ = DialogResponse.NEGATIVE Then
			Set = False
			Ch = "-"
		Else
			Return
		End If
		For i = 0 To NumberOfRows - 1
			Private GPSloc As GPSLocation
			Private lbl1 As Label
			GPSloc = Main.GPSPath.Get(i)
			GPSloc.Marker = Set
			Main.GPSPath.Set(i, GPSloc)
			n = i * NumberOfColumns + 8
			lbl1 = scvGPSPath1.Panel.GetView(n)
			lbl1.Text = Ch
		Next
	End Select
End Sub

Sub DispDistance(Distance As Double) As String
	' returns a string of a distance value according to the selected scale
	Select Main.DistanceUnitIndex
	Case 0	' m
		Return NumberFormat2(Distance  * Main.DistanceUnitRatio(Main.DistanceUnitIndex), 1 ,1, 1, False)
	Case 1, 2	' km  mile
		Return NumberFormat2(Distance  * Main.DistanceUnitRatio(Main.DistanceUnitIndex), 1 ,4, 4, False)
	End Select
End Sub

Sub DispAltitude(Altitude As Double) As String
	' returns a string of an altitude value according to the selected scale
	Select Main.AltitudeUnitIndex
	Case 0	' m
		Return NumberFormat2(Altitude  * Main.AltitudeUnitRatio(Main.AltitudeUnitIndex), 1 ,2, 2, False)
	Case 1	' feet
		Return NumberFormat2(Altitude  * Main.AltitudeUnitRatio(Main.AltitudeUnitIndex), 1 ,1, 1, False)
	End Select
End Sub

Sub UpdateDispAltitude
	Private i, n As Int
	
	Private lbl1 As Label
	lbl1 = pnlGPSPathHeader1.GetView(2)
	lbl1.Text = "Altitude" & CRLF & "[" & Main.AltitudeUnitText(Main.AltitudeUnitIndex) & "]"
	
	For i = 0 To NumberOfRows - 1
		Private GPSloc As GPSLocation
		GPSloc = Main.GPSPath.Get(i)
		Private lbl1 As Label
		n = i * NumberOfColumns + 2
		lbl1 = scvGPSPath1.Panel.GetView(n)
		lbl1.Text = DispAltitude(GPSloc.Altitude)
	Next
End Sub

Sub UpdateDispSpeed
	Private i, n As Int
	
	Private lbl1 As Label
	lbl1 = pnlGPSPathHeader1.GetView(5)
	lbl1.Text = "Speed" & CRLF & "[" & Main.SpeedUnitText(Main.SpeedUnitIndex) & "]"
	
	For i = 0 To NumberOfRows - 1
		Private GPSloc As GPSLocation
		GPSloc = Main.GPSPath.Get(i)
		Private lbl1 As Label
		n = i * NumberOfColumns + 5
		lbl1 = scvGPSPath1.Panel.GetView(n)
		lbl1.Text = NumberFormat2(GPSloc.Speed * Main.SpeedUnitRatio(Main.SpeedUnitIndex), 1 ,2, 0, False)
	Next
End Sub

Sub UpdateDispDistance
	Private i, n As Int
	
	Private lbl1 As Label
	lbl1 = pnlGPSPathHeader1.GetView(6)
	Private lbl2 As Label
	lbl2 = pnlGPSPathHeader1.GetView(7)

	lbl1.Text = "Distance" & CRLF & "[" & Main.DistanceUnitText(Main.DistanceUnitIndex) & "]"
	lbl2.Text = "Dist tot" & CRLF & "[" & Main.DistanceUnitText(Main.DistanceUnitIndex) & "]"
	For i = 0 To NumberOfRows - 1
		Private GPSloc As GPSLocation
		GPSloc = Main.GPSPath.Get(i)
		Private lbl1 As Label
		n = i * NumberOfColumns + 6
		lbl1 = scvGPSPath1.Panel.GetView(n)
		lbl1.Text = DispDistance(GPSloc.Distance)
		Private GPSloc As GPSLocation
		GPSloc = Main.GPSPath.Get(i)
		Private lbl1 As Label
		n = i * NumberOfColumns + 7
		lbl1 = scvGPSPath1.Panel.GetView(n)
		lbl1.Text = DispDistance(GPSloc.DistTot)
	Next
End Sub


